//--------------------------------------------------------------//
// AlphaKey
//
// Copyright (c) LWKS Software Ltd.  All Rights Reserved
//--------------------------------------------------------------//
#include "_utils.fx"

int _LwksEffectInfo
<
   string EffectGroup = "GenericPixelShader";
   string Description = "Alphakey";
   string Category    = "Keying";
   bool CanSize       = true;
> = 0;

//--------------------------------------------------------------//
// Inputs
//--------------------------------------------------------------//
DeclareInput( fg, FgSampler );
DeclareInput( bg, BgSampler );

//--------------------------------------------------------------//
// Pixel Shader
//--------------------------------------------------------------//
float4 ps_main( float2 fgPos : TEXCOORD1, float2 bgPos : TEXCOORD2 ) : COLOR
{
   float4 fgPix = ReadPixel( FgSampler, fgPos );
   float4 bgPix = ReadPixel( BgSampler, bgPos );

   float4 ret = float4( fgPix.a * fgPix ) + ( ( 1.0 - fgPix.a ) * bgPix );
   ret.a = 1.0;

   return ret;
}

//--------------------------------------------------------------//
// Techniques
//--------------------------------------------------------------//
technique AlphaKey
{
   pass Single_Pass
   {
      PixelShader = compile PROFILE ps_main();
   }
}

