//--------------------------------------------------------------//
// Flat Colour Effects
//
// Copyright (c) LWKS Software Ltd.  All Rights Reserved
//--------------------------------------------------------------//
#include "_utils.fx"

int _LwksEffectInfo
<
   string EffectGroup    = "GenericPixelShader";
   string Description    = "Colour Matte";
   string Category       = "Mattes";
   bool CanSize          = true;
   bool HasMinOutputSize = true;
> = 0;

//--------------------------------------------------------------//
// Params
//--------------------------------------------------------------//

float4 Colour
<
   string Description = "Colour";
> = { 1.0, 1.0, 1.0, 1.0 };

//--------------------------------------------------------------//
// Inputs
//--------------------------------------------------------------//

DeclareInput( Input, InputSampler );

//--------------------------------------------------------------//
// Code
//--------------------------------------------------------------//
float4 ps_main( float2 xy : TEXCOORD1 ) : COLOR
{
   float4 bg = ReadPixel( InputSampler, xy );
   float4 ret = lerp( bg, Colour, Colour.a );
   ret.a = bg.a;

   return ret;
}

//--------------------------------------------------------------//
// Technique Section for Image Processing Effects
//--------------------------------------------------------------//
technique FlatColour { pass Single_Pass { PixelShader = compile PROFILE ps_main(); } }
